03-04 创建和编辑AutoCAD实体四 编辑二维命名对象 7

9、Edit Polylines编辑多段线

2D and 3D polylines,rectangles,polygons,donuts,and 3D polygon meshes are all polyline variants and are edited in the same way.

二维多段线和三维多段线、矩形、多边形、圆环以及三维多边形网格都是多段线的变体,可以使用相同的方法对其进行编辑。

AutoCAD recognizes both fit polylines and spline-fit polylines. A spline-fit polyline uses a curve fit,similar to a B-spline. There are two kinds of spline-fit polylines: quadratic and cubic. Both polylines are controlled by the SPLINETYPE system variable. A fit polyline uses standard curves for curve fit and utilizes any tangent directions set on any given vertex.

AutoCAD能够识别拟合多段线和样条曲线拟合多段线。样条曲线拟合多段线使用曲线拟合而成,类似于B样条曲线。有两种样条曲线拟合多段线:二次的和三次的,两种多段线均由系统变量SPLINETYPE控制。拟合多段线使用标准曲线利用在给定顶点设置切线方向拟合而成。

To edit a polyline,use the properties and methods of the Polyline,Polyline2d,or Polyline3d object. Use the following properties and methods to open or close a polyline,change the coordinates of a polyline vertex,or add a vertex:

使用Polyline对象、 Polyline2d对象或Polyline3d对象的属性和方法来编辑多段线。下列属性和方法用于开放或闭合多段线、改变多段线顶点坐标、增加顶点等:

Closed 属性

Opens or closes the polyline. 开放或闭合多段线;

ConstantWidth 属性

Sets the constant width for a lightweight and 2D polyline. 设置轻量级和2D多段线宽度常量;

AppendVertex 方法

Adds a vertex to a 2D or 3D polyline. 给2D或3D多段线增加顶点;

AddVertexAt 方法

Adds a vertex to a lightweight polyline. 给轻量级多段线增加顶点;

ReverseCurve 方法

Reverses the direction of the polyline. 掉换多段线方向;

Use the following methods to update the bulge or width of a polyline:

下列方法用于修改多段线的凸度或宽度:

SetBulgeAt 方法

Sets the bulge of a light polyline,given the segment index. 给定线段索引,设置多段线的凸度;

SetStartWidthAt 方法

Sets the start width of a lightweight polyline,given the segment index. 给定线段索引,设置轻量级多段线的起始宽度;

Straighten方法

Straightens a 2D or 3D polyline. 拉直2D或3D多段线

For more information about editing polylines,see “Modify or Join Polyline” in theUser's Guide.

关于编辑多段线的更多内容,见AutoCAD用户指南中的“修改或连结多段线”。

Edit a polyline 编辑多段线

This example creates a lightweight polyline. It then adds a bulge to the third segment of the polyline,appends a vertex to the polyline,changes the width of the last segment,and finally closes the polyline.

本例创建一条轻量级多段线,然后将第三条线段变成曲线(添加凸度)、追加一个顶点、修改最后那条线段的宽度,最后闭合该多段线。

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

<CommandMethod("EditPolyline")> _

Public Sub EditPolyline()

'' Get the current document and database

Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

Dim acCurDb As Database = acDoc.Database

'' Start a transaction

Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

'' Open the Block table for read

Dim acBlkTbl As BlockTable

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,_

OpenMode.ForRead)

'' Open the Block table record Model space for write

Dim acBlkTblRec As BlockTableRecord

acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace),_

OpenMode.ForWrite)

'' Create a lightweight polyline

Dim acPoly As Polyline = New Polyline()

acPoly.AddVertexAt(0,New Point2d(1,1),0)

acPoly.AddVertexAt(1,2),0)

acPoly.AddVertexAt(2,New Point2d(2,0)

acPoly.AddVertexAt(3,New Point2d(3,0)

acPoly.AddVertexAt(4,New Point2d(4,4),0)

'' Add the new object to the block table record and the transaction

acBlkTblRec.AppendEntity(acPoly)

acTrans.AddNewlyCreatedDBObject(acPoly,True)

'' Sets the bulge at index 3

acPoly.SetBulgeAt(3,-0.5)

'' Add a new vertex

acPoly.AddVertexAt(5,0)

'' Sets the start and end width at index 4

acPoly.SetStartWidthAt(4,0.1)

acPoly.SetEndWidthAt(4,0.5)

'' Close the polyline

acPoly.Closed = True

'' Save the new objects to the database

acTrans.Commit()

End Using

End Sub

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

[CommandMethod("EditPolyline")]

public static void EditPolyline()

{

// Get the current document and database获取当前文档和数据库

Document acDoc = Application.DocumentManager.MdiActiveDocument;

Database acCurDb = acDoc.Database;

// Start a transaction启动事务

using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

{

// Open the Block table for read以读打开块表

BlockTable acBlkTbl;

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

OpenMode.ForRead) as BlockTable;

// Open the Block table record Model space for write

// 以写打开块表记录模型空间

BlockTableRecord acBlkTblRec;

acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

OpenMode.ForWrite) as BlockTableRecord;

// Create a lightweight polyline创建轻型多段线

Polyline acPoly = new Polyline();

acPoly.AddVertexAt(0,new Point2d(1,0);

acPoly.AddVertexAt(1,0);

acPoly.AddVertexAt(2,new Point2d(2,0);

acPoly.AddVertexAt(3,new Point2d(3,0);

acPoly.AddVertexAt(4,new Point2d(4,0);

// Add the new object to the block table record and the transaction

//将新对象添加到块表记录和事务

acBlkTblRec.AppendEntity(acPoly);

acTrans.AddNewlyCreatedDBObject(acPoly,true);

// Sets the bulge at index 3设置线段3的凸度

acPoly.SetBulgeAt(3,-0.5);

// Add a new vertex添加新顶点

acPoly.AddVertexAt(5,0);

// Sets the start and end width at index 4设置线段4的起止宽度

acPoly.SetStartWidthAt(4,0.1);

acPoly.SetEndWidthAt(4,0.5);

// Close the polyline闭合多段线

acPoly.Closed = true;

// Save the new objects to the database提交修改

acTrans.Commit();

}

}

VBA/ActiveX Code Reference

Sub EditPolyline()

Dim plineObj As AcadLWPolyline

Dim points(0 To 9) As Double

' Define the 2D polyline points

points(0) = 1: points(1) = 1

points(2) = 1: points(3) = 2

points(4) = 2: points(5) = 2

points(6) = 3: points(7) = 2

points(8) = 4: points(9) = 4

' Create a light weight Polyline object

Set plineObj = ThisDrawing.ModelSpace. _

AddLightWeightPolyline(points)

' Add a bulge to segment 3

plineObj.SetBulge 3,-0.5

' Define the new vertex

Dim newVertex(0 To 1) As Double

newVertex(0) = 4: newVertex(1) = 1

' Add the vertex to the polyline

plineObj.AddVertex 5,newVertex

' Set the width of the new segment

plineObj.SetWidth 4,0.1,0.5

' Close the polyline

plineObj.Closed = True

plineObj.Update

End Sub

版权声明:本文内容由互联网用户自发贡献,该文观点与技术仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 dio@foxmail.com 举报,一经查实,本站将立刻删除。

相关推荐


Format[$] ( expr [ , fmt ] ) format 返回变体型 format$ 强制返回为文本 -------------------------------- 数字类型的格式化 --------------------------------     固定格式参数:     General Number 普通数字,如可以用来去掉千位分隔号     format$("100,1
VB6或者ASP 格式化时间为 MM/dd/yyyy 格式,竟然没有好的办法, Format 或者FormatDateTime 竟然结果和系统设置的区域语言的日期和时间格式相关。意思是尽管你用诸如 Format(Now, "MM/dd/yyyy"),如果系统的设置格式区域语言的日期和时间格式分隔符是"-",那他还会显示为 MM-dd-yyyy     只有拼凑: <%response.write
在项目中添加如下代码:新建窗口来显示异常信息。 Namespace My ‘全局错误处理,新的解决方案直接添加本ApplicationEvents.vb 到工程即可 ‘添加后还需要一个From用来显示错误。如果到这步还不会则需要先打好基础啦 ‘======================================================== ‘以下事件
转了这一篇文章,原来一直想用C#做k3的插件开发,vb没有C#用的爽呀,这篇文章写与2011年,看来我以前没有认真去找这个方法呀。 https://blog.csdn.net/chzjxgd/article/details/6176325 金蝶K3 BOS的插件官方是用VB6编写的,如果  能用.Net下的语言工具开发BOS插件是一件很愉快的事情,其中缘由不言而喻,而本文则是个人首创,实现在了用V
Sub 分列() ‘以空格为分隔符,连续空格只算1个。对所选中的单元格进行处理 Dim m As Range, tmpStr As String, s As String Dim x As Integer, y As Integer, subStr As String If MsgBox("确定要分列处理吗?请确定分列的数据会覆盖它后面的单元格!", _
  窗体代码 1 Private Sub Text1_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single) 2 Dim path As String, hash As String 3 For Each fil
  Imports MySql.Data.MySqlClient Public Class Form1 ‘ GLOBAL DECLARATIONS Dim conString As String = "Server=localhost;Database=net2;Uid=root;Pwd=123456;" Dim con As New MySqlConnection
‘導入命名空間 Imports ADODB Imports Microsoft.Office.Interop   Private Sub A1() Dim Sql As String Dim Cnn As New ADODB.Connection Dim Rs As New ADODB.Recordset Dim S As String   S = "Provider=OraOLEDB.Oracl
Imports System.IO Imports System.Threading Imports System.Diagnostics Public Class Form1 Dim A(254) As String    Function ping(ByVal IP As Integer) As String Dim IPAddress As String IPAddress = "10.0.
VB运行EXE程序,并等待其运行结束 参考:https://blog.csdn.net/useway/article/details/5494084 Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long Pr
今天碰到一个问题,登陆的时候,如果不需要验证手机号为空,则不去验证手机号 因为登陆的时候所有的验证信息都存放在一个数组里 Dim CheckUserInfo() As String ={UserBirthday, SecEmail, UserMob, UserSex, RealNameFirst, RealName, CheckCardID, CheckCardType, Contactemail
在VB6.0中,数据访问接口有三种: 1、ActiveX数据对象(ADO) 2、远程数据对象(RDO) 3、数据访问对象(DAO) 1.使用ADO(ActiveX Data Objec,ActiveX数据对象)连接SQL Server 1)使用ADO控件连接 使用ADO控件的ConnectionString属性就可以连接SQL Server,该属性包含一个由分号分隔的argument=value语
注:大家如果没有VB6.0的安装文件,可自行百度一下下载,一般文件大小在200M左右的均为完整版的软件,可以使用。   特别提示:安装此软件的时候最好退出360杀毒软件(包括360安全卫士,电脑管家等,如果电脑上有这些软件的话),因为现如今的360杀毒软件直接会对VB6.0软件误报,这样的话就可能会在安装过程中被误报阻止而导致安装失败,或者是安装后缺乏很多必须的组件(其它的杀毒软件或安全卫士之类的
Private Sub Form_Load() Call conndb End Sub Private Function conndb() Dim cn As New ADODB.Connection Dim rs As New ADODB.Recordset Dim strCn, sql As String Dim db_host As String Dim db_user As String
  PPSM06S70:  Add  moddate  EDITSPRINTJOB:  MAX(TO_CHAR(ETRN.MODDATE, ‘yyyy/mm/dd/HH24:MI AM‘)) ACTUAL_SHIPDATE   4.Test Scenario (1) :Query SQL Test DN:8016578337 SELECT CTRN.TKCTID TRUCK_ID,        
  沒有出現CrystalReportViewer時,須安裝CRforVS_13_0. 新增1個數據集,新增1個數據表,添加二列,列名要和資料庫名一樣. 修改目標Framework 修改app.config, <startup >改成<startup useLegacyV2RuntimeActivationPolicy ="true">  CrystalReport1.rpt增加數據庫專家 在表單
Imports System.Threading Imports System Public Class Form1 Dim th1, th2 As Thread Public Sub Method1() Dim i As Integer For i = 1 To 100 If Me.Label1.BackColor =
Friend Const PROCESS_ALL_ACCESS = &H1F0FFF = 2035711 Friend Const PROCESS_VM_READ = &H10 Friend Const PROCESS_VM_WRITE = &H20 Friend Const PAGE_READONLY = &H2 Friend Const PAGE_READWRITE = &H4 Friend
以下代码随手写的 并没有大量测试 效率也有待提升 如果需要C#的请自行转换 Function SplitBytes(Data As Byte(), Delimiter As Byte()) As List(Of Byte()) Dim i = 0 Dim List As New List(Of Byte()) Dim bytes As New
Imports System.Data.SqlClient Public Class Form1 REM Public conn1 As SqlConnection = New SqlConnection("server=.; Integrated Security=False;Initial Catalog= mydatabase1; User ID= sa;password")